<?php

class rex_version_watch {

    static function show_latest_version() {
        global $REX;

        $temp_datei = $REX['INCLUDE_PATH'] . '/generated/files/latest_version.txt';
        $datei = "http://www.redaxo.org/de/latestversion";

        if (file_exists($temp_datei) && filemtime($temp_datei) + 86400 > time()) {

            $content = file_get_contents($datei);

            clearstatcache(); //php cache leeren
        } else {

            ini_set('allow_url_fopen', '1');

            if (file_get_contents(__FILE__) && ini_get('allow_url_fopen')) {

                $content = file_get_contents($datei);
            } elseif (function_exists('curl_version')) {

                $curl = curl_init();
                curl_setopt($curl, CURLOPT_URL, $datei);
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
                $content = curl_exec($curl);
                curl_close($curl);
            } else {

                return false;
            }

            if (isset($content)) {

                $content = substr(htmlspecialchars(trim($content)), 0, 8);

                /*
                 * zwischen speichern
                 */
                #unlink($temp_datei);
                file_put_contents($temp_datei, $content);
            }
        }
        $version = explode('.', $content);



        return $version;
    }

    static function compare_version() {
        global $REX;

        $latestVersion = self::show_latest_version();


        if (!$latestVersion) {

            return false;
        }

        settype($REX['VERSION'], "integer");
        settype($REX['SUBVERSION'], "integer");
        settype($REX['MINORVERSION'], "integer");

        $rexVersion[0] = $REX['VERSION'];
        $rexVersion[1] = $REX['SUBVERSION'];
        $rexVersion[2] = $REX['MINORVERSION'];

        settype($latestVersion[0], "integer");
        settype($latestVersion[1], "integer");
        settype($latestVersion[2], "integer");


        if ($rexVersion[0] < $latestVersion[0] || $rexVersion[1] < $latestVersion[1] || $rexVersion[2] < $latestVersion[2]) {

            $latestVersionSring = ' / <a title="Latest Version" style="font-weight:bold;" href="http://redaxo.org/" onclick="window.open(this.href); return false">'
                    . $latestVersion[0] . '.' . $latestVersion[1] . '.' . $latestVersion[2] . '</a>';
        } else {
            $latestVersionSring = '';
        }

        return $latestVersionSring;
    }

    static function addToOutputFilter($params) {
        global $REX;

        $style = ' style="float:right;color:#fff;padding:2px; font-weight:bold"';
        $replace = '<div id="rex-website">'
                . '<div class="be-utilities-version_watch"' . $style . '>'
                . '<span  title="Current Version">' . $REX['VERSION'] . '.' . $REX['SUBVERSION'] . '.' . $REX['MINORVERSION']
                . '</span>'
                . self::compare_version() . ''
                . ''
                . '</div>';
        $params['subject'] = str_replace('<div id="rex-website">', $replace, $params['subject']);



        return $params['subject'];
    }

}
